EDIT - task #6522

package cdm-server in docker container
03/17/2017 08:32 AM - Andreas Kohlbecker

Status: Closed Start date:

Priority: New Due date:

Assignee: Andreas Kohlbecker % Done: 100%
Category: cdmserver Estimated time: 0:00 hour
Target version: Release 5.5

Severity: normal

Description

for easier distribution of the cdm-server it would be advantageous to package the cdm-server into a docker container.
Docker doc:

e Dockerfile reference
e Docker Getting Startet
o Bind mounts

e Docker Compose
o Compose File Reference#restart

Running java inside docker containers:

e DZone - Java Inside Docker: What You Must Know to Not FAIL
e DZone - JVM Advent Calendar: Docker and the JVM
¢ https://blog.docker.com/2018/04/improved-docker-container-integration-with-java-10/

On creating docker containers with maven:

e https://jaxenter.de/docker-mit-maven-steuern-20211
¢ https://github.com/fabric8io/shootout-docker-maven

The fabric8io/docker-maven-plugin seems to the the most mature and suitable plugin.

On configuring containers and images via ENV and ARGS, etc: https://vsupalov.com/docker-arg-env-variable-guide

On running a container as a system service, restart policies etc.

e https://docs.docker.com/config/containers/start-containers-automatically : A) --restart flag when using the docker run command
B) --live-restore flag of the dockerd command, C) Use a process manager
o https://docs.docker.com/engine/reference/run/#restart-policies---restart
o https://docs.docker.com/config/containers/live-restore/

==> we should use
docker run -dit —--restart unless-stopped

e -d, --detach : Run container in background and print container ID
e -i, --interactive: Keep STDIN open even if not attached

-t, --tty: Allocate a pseudo-TTY

--restart unless-stopped: Restart the container unless it is explicitly stopped or Docker itself is stopped or restarted.

Deployment

to https://hub.docker.com

Organization for the EDIT Platform:

03/13/2024 1/5



https://docs.docker.com/engine/reference/builder/
https://docs.docker.com/get-started/
https://docs.docker.com/storage/bind-mounts/
https://docs.docker.com/compose/
https://docs.docker.com/compose/compose-file/#restart
https://dzone.com/articles/java-inside-docker-what-you-must-know-to-not-fail
https://dzone.com/articles/jvm-advent-calendar-docker-and-the-jvm
https://blog.docker.com/2018/04/improved-docker-container-integration-with-java-10/
https://jaxenter.de/docker-mit-maven-steuern-20211
https://github.com/fabric8io/shootout-docker-maven
https://github.com/fabric8io/docker-maven-plugin
https://vsupalov.com/docker-arg-env-variable-guide
https://docs.docker.com/config/containers/start-containers-automatically
https://docs.docker.com/engine/reference/run/#restart-policies---restart
https://docs.docker.com/config/containers/live-restore/
https://hub.docker.com

https://cloud.docker.com/u/cybertaxonomy/

organization name: cybertaxonomy
owners:
o kohlbecker
e repository: cdm-server
team : editdev
o members (so far):
= kohlbecker
= jenkinsintbgbm (jenkins-int-AT-bgbm.org)

The cdm-server image is available from hitps://hub.docker.com/r/cybertaxonomy/cdm-server/

To push images with maven add the following server section to the ~/.m2/settings.xml

<server>
<id>docker.io</id>
<username>username</username>
<password>S3cr3t</password>
</server>

Related issues:

Related to EDIT - task #5375: cdm-server without jsvc In Progress
Related to EDIT - feature request #8082: cdm-server docker image allows runni... New
Related to EDIT - task #10444: Add integration test with docker New

Associated revisions

Revision ed5ad657 - 01/18/2019 07:13 PM - Andreas Kohlbecker

ref #6522 adding fairly complete set of configuration and documentation for delpoying the cdm-server as docker image

Revision d790e10d - 01/18/2019 07:30 PM - Andreas Kohlbecker

ref #6522 removing useless integration-test run config from docker plugin

Revision 4e1dd75e - 01/21/2019 07:40 AM - Andreas Kohlbecker

ref #6522 commenting run configuration

Revision 35066a11 - 01/21/2019 12:00 PM - Andreas Kohlbecker

ref #6522 cleaning up docker config files

Revision 61¢c9e055 - 01/21/2019 04:33 PM - Andreas Kohlbecker

ref #6522 maven assembly moved into package phase

Revision b2c1eebc - 01/21/2019 05:32 PM - Andreas Kohlbecker

ref #6522 fixing problems with ARGs in Dockerfiles and more documentation

History

#1 - 03/17/2017 08:34 AM - Andreas Kohlbecker

[Saskia Gennrich]

Wir versuchen hier am Museum Teile unserer Infrastruktur mit Docker zu realisieren.
Mit jsvc hab ich ein paar Probleme das im Docker zum laufen zu bekommen.
Spricht etwas dagegen die jar ,normal“ zu starten mit

java S$JAVA_OPTIONS -jar cdm-server.jar SCDMSERVER_ARGS

#2 - 03/17/2017 08:35 AM - Andreas Kohlbecker

jsve macht unter Docker ziemliche Probleme, an dieser Stelle sind wir auch schon stecken geblieben als wir mal auf die Schnelle den cdm-server in
Docker verpacken wollten.

Die jar normal zu starten ist nattrlich méglich, allerdings l14uft der Server dann nicht als Hintergrundprozess, fiir Produktionssysteme nicht gerade
optimal.
https://cloud.docker.com/u/cybertaxonomy/
https://hub.docker.com/r/cybertaxonomy/cdm-server/

Jetty hatte friiher auch jsvc verwendet um als Daemon zu starten, mittlerweile wird das bei Jetty aber auch anders gemacht. Ich habe mir das alles
noch nicht im Detail angesehen aber ein Ticket dafur angelegt: #5375

Ich habe auch groBes Interesse daran eine solide Lésung fur dieses Problem zu finden.

Viele GruB3e
Andreas

#3 - 03/17/2017 08:35 AM - Andreas Kohlbecker
- Related to task #5375: cdm-server without jsvc added

#4 - 03/17/2017 08:37 AM - Andreas Kohlbecker

[Saskia Gennrich]

Ob der CDM im Docker-Container als Daemon |&uft oder nicht sollte ja egal sein. Man kann den Docker-Prozess ja als Hintergrund-Prozess starten.
Ich hab gelesen, dass jsvc auch dafiir benutzt wird um den Prozess neu zu starten, wenn er abstiirzt. Dass kann ja Docker prinzipiell auch, obwohl
ich damit noch keine Erfahrungen gemacht habe. (restart=always)

Falls es dich interessiert hab ich mal das Dockerfile angeh&ngt, mit dem ich das Image baue. Im Ordner .cdmLibrary liegt nur die datasource.xml und
cdm-server-realm.properties:

FROM anapsix/alpine-java:8

COPY cdm-server-4.0.0.jar /root/cdm-server.jar
COPY cdmserver/.cdmLibrary /root/.cdmLibrary

#-Dspring.profiles.active=remoting is needed for the Taxonomic Editor to connect to the cdm server
ENV NAME=cdmserver \
DESC="CDM Server" \
CDM_HOME=/root \
LOGDIR="/log/$SNAME" \
CONTEXT_PATH_PREFIX=/ \
CDMSERVER_PORT=8080 \
CDMSERVER_SHUTDOWN=30
ENV JAVA_OPTIONS="-Xmx1024M -XX:PermSize=128m —-XX:MaxPermSize=192m -XX:+UseConcMarkSweepGC -XX:+CMSClassUnload
ingEnabled -XX:+CMSPermGenSweepingEnabled -Duser.home=$CDM_HOME -Dspring.profiles.active=remoting”

ENV CDMSERVER_ARGS="-httpPort=$CDMSERVER_PORT -1ogdir=$LOGDIR -contextPathPrefix=$CONTEXT_PATH_PREFIX"
EXPOSE $CDMSERVER_PORT
CMD Jjava $JAVA_OPTIONS -jar /root/cdm-server.jar $CDMSERVER_ARGS

Viele GruB3e
Saskia

#5 - 03/17/2017 08:42 AM - Andreas Kohlbecker

- Description updated

Yesterday | found this potentially useful article on running jvm applications in docker containers: DZone - Java Inside Docker: What You Must Know to
Not FAIL

#6 - 11/13/2018 01:24 PM - Andreas Kohlbecker
- Description updated

#7 - 12/17/2018 09:24 AM - Andreas Kohlbecker
- Description updated

#8 - 12/19/2018 09:59 AM - Andreas Kohlbecker
- Description updated

#9 - 12/19/2018 10:01 AM - Andreas Kohlbecker
- Description updated

#10 - 01/16/2019 08:55 AM - Andreas Kohlbecker

- Description updated

03/13/2024 3/5


https://dev.e-taxonomy.eu/redmine/issues/5375
https://dzone.com/articles/java-inside-docker-what-you-must-know-to-not-fail
https://dzone.com/articles/java-inside-docker-what-you-must-know-to-not-fail

#11 - 01/16/2019 02:10 PM - Andreas Kohlbecker
- Description updated

#12 - 01/16/2019 02:11 PM - Andreas Kohlbecker
- Description updated

#13 - 01/16/2019 03:22 PM - Andreas Kohlbecker
- Description updated

#14 - 01/17/2019 12:56 PM - Andreas Kohlbecker

- Description updated

#15 - 01/17/2019 12:57 PM - Andreas Kohlbecker

- Description updated

#16 - 01/18/2019 05:15 PM - Andreas Kohlbecker

- Description updated

#17 - 01/18/2019 05:18 PM - Andreas Kohlbecker

- Description updated

#18 - 01/18/2019 05:20 PM - Andreas Kohlbecker

- Description updated

#19 - 01/18/2019 06:50 PM - Andreas Kohlbecker

- Description updated

#20 - 01/18/2019 07:01 PM - Andreas Kohlbecker

- Description updated

#21 - 01/18/2019 07:10 PM - Andreas Kohlbecker

- Description updated

#22 - 01/21/2019 07:43 AM - Andreas Kohlbecker
- Tags set to phycobank
- Status changed from New to In Progress

- Target version changed from Unassigned CDM tickets to Release 5.5

#23 - 01/21/2019 12:01 PM - Andreas Kohlbecker
- Status changed from In Progress to Resolved

- % Done changed from 0 to 50

#24 - 01/22/2019 11:02 PM - Andreas Kohlbecker

- Description updated

#25 - 01/22/2019 11:02 PM - Andreas Kohlbecker

- Description updated

#26 - 01/28/2019 02:49 PM - Andreas Kohlbecker
- Status changed from Resolved to Closed

- % Done changed from 50 to 100

#27 - 02/08/2019 11:34 AM - Andreas Kohlbecker

- Related to feature request #8082: cdm-server docker image allows running the cdm-server as non root user added

#28 - 12/19/2023 02:39 PM - Andreas Miiller
- Related to task #10444: Add integration test with docker added
